--
-- ChangeLowerLinkEvents
--
-- @package 	fs17.saphir_plowstar.specializations.changeLowerLinkEvents
-- @auhtor 		IceBlade <www.cg-production.com>
-- @copyright 	2018 CG-Production
-- @license    	www.cg-production.com/license/FS_Script_Licence_2018_1.txt
-- @version		1.0.0.0
-- @history		<1.0.0.0> <04.03.2018> creation
-- 

ChangeLowerLinkEvents = {};
ChangeLowerLinkEvents_mt = Class(ChangeLowerLinkEvents, Event);
InitEventClass(ChangeLowerLinkEvents, 'ChangeLowerLinkEvents');

function ChangeLowerLinkEvents:emptyNew()
    local self = Event:new(ChangeLowerLinkEvents_mt);
    return self;
end;

function ChangeLowerLinkEvents:new(vehicle, position)
    local self = ChangeLowerLinkEvents:emptyNew();
    self.vehicle = vehicle;
    self.position = position;
    return self;
end;

function ChangeLowerLinkEvents:writeStream(streamId, connection)
    writeNetworkNodeObject(streamId, self.vehicle);
    streamWriteUInt8(streamId, self.position);
end

function ChangeLowerLinkEvents:readStream(streamId, connection)
    self.vehicle = readNetworkNodeObject(streamId);
    self.position = streamReadUInt8(streamId);
    self:run(connection);
end

function ChangeLowerLinkEvents:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, nil, connection, self.vehicle, self.position);
    end;
    self.vehicle:setPosition(self.position, true);
end

function ChangeLowerLinkEvents.sendEvent(vehicle, position, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(ChangeLowerLinkEvents:new(vehicle, position), nil, nil, vehicle);
        else
            g_client:getServerConnection():sendEvent(ChangeLowerLinkEvents:new(vehicle, position));
        end;
    end
end;