--
-- Subsoiler
--
-- @package 	fs17.saphir_plowstar.specializations.subsoiler
-- @auhtor 		IceBlade <www.cg-production.com>
-- @copyright 	2018 CG-Production
-- @license    	www.cg-production.com/license/FS_Script_Licence_2018_1.txt
-- @version		1.0.0.1
-- @history		<1.0.0.0> <04.03.2018> creation
-- 				<1.0.0.1> <08.03.2018> added specialization 'Cultivator' requirement
-- 

Subsoiler = {};

function Subsoiler.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Cultivator, specializations);
end;

function Subsoiler:preLoad()
end;

function Subsoiler:load()
	self.processCultivatorAreas = Utils.overwrittenFunction(self.processCultivatorAreas, Subsoiler.processCultivatorAreas);
end;

function Subsoiler:delete()
end;

function Subsoiler:readStream(streamId, connection)
end;

function Subsoiler:writeStream(streamId, connection)
end;

function Subsoiler:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Subsoiler:keyEvent(unicode, sym, modifier, isDown)
end;

function Subsoiler:update(dt)
end;

function Subsoiler:updateTick(dt)
end;

function Subsoiler:draw()
end;

function Subsoiler:processCultivatorAreas(superFunc, workAreas, limitToField, limitGrassDestructionToField, angle)
    local areaSum = 0;
    for _, area in pairs(workAreas) do
        local x, z, x1, z1, x2, z2 = unpack(area);
        Utils.updatePloughArea(x, z, x1, z1, x2, z2, not limitToField, not limitGrassDestructionToField, angle);
        areaSum = areaSum + Utils.updateCultivatorArea(x, z, x1, z1, x2, z2, not limitToField, not limitGrassDestructionToField, angle);
    end;
    return areaSum;
end;